/**
Copyright: 2024 Contrast Security, Inc
  Contact: support@contrastsecurity.com
  License: Commercial

  NOTICE: This Software and the patented inventions embodied within may only be
  used as part of Contrast Security’s commercial offerings. Even though it is
  made available through public repositories, use of this Software is subject to
  the applicable End User Licensing Agreement found at
  https://www.contrastsecurity.com/enduser-terms-0317a or as otherwise agreed
  between Contrast Security and the End User. The Software may not be reverse
  engineered, modified, repackaged, sold, redistributed or otherwise used in a
  way not consistent with the End User License Agreement.
*/
'use strict';
const { isASCIIAlphaNumeric, isAllowableSpecialChar } = require('./common');

module.exports = function isSafe(value) {
  if (value === '*') {
    return true;
  }

  return matchesSpec(stripWeakMatch(value));
};

/**
 * Iterates over every etag to ensure
 * it matches the specification
 * See: https://www.w3.org/Protocols/rfc2616/rfc2616-sec14.html
 *
 * Note: This is not how java did it, theirs looks like it has holes
 *
 * @param {String} value value of if-non-match header
 * @return {Boolean} if value is safe and matches spec
 */
function matchesSpec(value) {
  const etags = value.split(', ');
  let safe = true;
  etags.forEach((etag) => {
    etag = stripWeakMatch(etag);

    if (!quoteWrapped(etag)) {
      safe = false;
      return;
    }

    for (let i = 0; i < etag.length; i++) {
      const char = etag[i];
      const charCode = etag.charCodeAt(i);
      const isAlphaNumeric = isASCIIAlphaNumeric(charCode);
      const allowableSpecial = isAllowableSpecialChar(['-', '"'], char);

      if (!isAlphaNumeric && !allowableSpecial) {
        safe = false;
        return;
      }
    }
  });

  return safe;
}

// removes W/ from etag if it exists
function stripWeakMatch(value) {
  return value.startsWith('W/"') ? value.substring(2) : value;
}

// checks if an etag is wrapped in ""
function quoteWrapped(value) {
  return value.startsWith('"') && value.endsWith('"');
}
